import QtQuick 1.0
import QtDesktop 0.1
Rectangle {

    property int textSize:20
    property color textColor:"black"
        id:dialog
        CalibrateDialogDesktop {
            id:joyStickCalibrator
        }

        anchors.fill: parent
        TabFrame {
        Tab {
             title: "Display"
          id: displayTab
          anchors.fill: parent
       //   anchors.leftMargin:50;anchors.rightMargin:50

          Grid {
              columns:2
              id: dialogcontent
              anchors.leftMargin:50;anchors.rightMargin:50
              spacing: 20

/*           Text {
                  font.pixelSize  :textSize
                  text:"UI Style"

          }
        ComboBox {
              id: activeUICombo;
              model:  ListModel {
                id: choices
                ListElement { text: "MeeGo/Harmattan";file:"ardrone_harmattan.qml" }
                ListElement { text: "Desktop";file:"ardrone_desktop.qml" }
                }
              onSelectedIndexChanged: {
                  console.debug("onSelectedIndexChanged " + selectedText + ", " + choices.get(selectedIndex).file);
                  drone.confActiveUI=choices.get(selectedIndex).file
              }
              selectedText:drone.confActiveUI
              KeyNavigation.tab: t1
              KeyNavigation.backtab: button2
           }
*/
          Text {
              width:200
              text: "Drone IP"
              color:textColor
              font.pixelSize  :textSize
           }

           TextField {
                  id: droneip
                  width: 200
                  height: 40
                  anchors.right: parent.right
                  text: drone.confDroneIp
                  onTextChanged:{drone.confDroneIp=text;}
           }

//          }

           Text {
              text: "Video 640x480 / Full Screen"
	      color:textColor
              font.pixelSize  :textSize
           }
           CheckBox {
              id: fullScreen
              checked:drone.confFullScreen
              anchors.right:parent.right
              onCheckedChanged:{drone.confFullScreen=checked;}
           }
           Text {
              color:textColor
              text: "Show debug"
              font.pixelSize  :textSize
           }
           CheckBox {
              id: showDebug
              checked:drone.confShowDebug
              anchors.right:parent.right
              onCheckedChanged:{drone.confShowDebug=checked;}
           }

           Text {
              text: "Show engine gauges"
              color:textColor
              font.pixelSize  :textSize

           }
           CheckBox {
              id: showGauges
              checked:drone.confShowGauges
              anchors.right:parent.right
              onCheckedChanged:{drone.confShowGauges=checked;}
           }

           Text {
              text: "Show horizon"
              color:textColor
              font.pixelSize  :textSize

           }
           CheckBox {
              id: showHorizon
              checked:drone.confShowHorizon
              anchors.right:parent.right
              onCheckedChanged:{drone.confShowHorizon=checked;}
           }
          } // Grid
          } // tab
          Tab {
              title: "Control"
              Grid {
                  columns:2
                  anchors.leftMargin:50;anchors.rightMargin:50
                  spacing: 20
           Text {
              text: "Acceleration Sensor for controll"
	      color:textColor
              font.pixelSize  :textSize
           }
           CheckBox {
              id: useAccelSw
              checked:drone.confUseAccel
              anchors.right:parent.right
              onCheckedChanged:{drone.confUseAccel=checked;}
           }

           Text {
               text: "Joystick"
              color:textColor
              font.pixelSize  :textSize
           }
           CheckBox {
              id: useJoySw
              checked:drone.confUseJoyStick
              anchors.right:parent.right
              enabled:js.haveJoyStick
              onCheckedChanged:{drone.confUseJoyStick=checked;}
           }

           Text {
               visible:drone.confUseJoyStick
               font.pixelSize  :textSize
               text:"\"" + js.joyStickName + "\""

           }
           Button {
               visible:drone.confUseJoyStick
               text:"Calibrate"
               anchors.right:parent.right
              onClicked:{   joyStickCalibrator.visible = true;
                   js.calibrate=true
               }
           }
           Text {
               visible:drone.confUseJoyStick
               font.pixelSize  :textSize
               text:"Show JoyStick Indicators"

           }
            CheckBox {
               visible:drone.confUseJoyStick
               checked:drone.confShowJSIndicators
               anchors.right:parent.right
               enabled:js.haveJoyStick
               onCheckedChanged:{drone.confShowJSIndicators=checked;}

           }


           Text {
              text: "Forward/backward gain"
	      color:textColor
              font.pixelSize  :textSize
           }

           Slider {
              id: forwardGain
              anchors.right:parent.right
              maximumValue:1.0
              stepSize:0.01
              value:drone.confForwardGain
              onValueChanged:{drone.confForwardGain=value;}
           }
           Text {
              text: "Right/Left gain"
	      color:textColor
              font.pixelSize  :textSize
           }

           Slider {
              id: rightGain
              anchors.right:parent.right
              maximumValue:1.0
              stepSize:0.01
              value:drone.confRightGain
              onValueChanged:{drone.confRightGain=value;}
           }
           Text {
              text: "accel ctrl treshold"
	      color:textColor
              font.pixelSize  :textSize
           }

           Slider {
              id: ctrlTreshold
              anchors.right:parent.right
              maximumValue:25.0
              value:drone.confCtrlTrsh
              onValueChanged:{drone.confCtrlTrsh=value;}
           }
          }
       }
        }
     }
