#ifndef JOYSTICK_H
#define JOYSTICK_H

#include <QObject>
#include <QTimer>
#include <QSettings>
#include <QDebug>
#include <QSettings>
#ifdef HAVE_SDL
#include <SDL/SDL.h>
#endif
class JoyStick : public QObject
{
    Q_OBJECT
    Q_PROPERTY(bool haveJoyStick READ haveJoyStick NOTIFY joyStickChanged)
    Q_PROPERTY(QString joyStickName READ joyStickName NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis1  READ rawAxis1 NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis2  READ rawAxis2 NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis3  READ rawAxis3 NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis4  READ rawAxis4 NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis5  READ rawAxis5 NOTIFY joyStickChanged)
    Q_PROPERTY(int rawAxis6  READ rawAxis6 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis1  READ maxAxis1 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis2  READ maxAxis2 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis3  READ maxAxis3 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis4  READ maxAxis4 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis5  READ maxAxis5 NOTIFY joyStickChanged)
    Q_PROPERTY(int maxAxis6  READ maxAxis6 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis1  READ minAxis1 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis2  READ minAxis2 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis3  READ minAxis3 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis4  READ minAxis4 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis5  READ minAxis5 NOTIFY joyStickChanged)
    Q_PROPERTY(int minAxis6  READ minAxis6 NOTIFY joyStickChanged)
    Q_PROPERTY(float axis1   READ axis1    NOTIFY joyStickChanged)
    Q_PROPERTY(float axis2   READ axis2    NOTIFY joyStickChanged)
    Q_PROPERTY(float axis3   READ axis3    NOTIFY joyStickChanged)
    Q_PROPERTY(float axis4   READ axis4    NOTIFY joyStickChanged)
    Q_PROPERTY(float axis5   READ axis5    NOTIFY joyStickChanged)
    Q_PROPERTY(float axis6   READ axis6    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis1   READ calAxis1    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis2   READ calAxis2    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis3   READ calAxis3    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis4   READ calAxis4    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis5   READ calAxis5    NOTIFY joyStickChanged)
    Q_PROPERTY(float calAxis6   READ calAxis6    NOTIFY joyStickChanged)
    Q_PROPERTY(float aileron  READ axis1 NOTIFY joyStickChanged)
    Q_PROPERTY(float elevator READ axis2 NOTIFY joyStickChanged)
    Q_PROPERTY(float throtle  READ axis3 NOTIFY joyStickChanged)
    Q_PROPERTY(float rudder   READ axis4 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis1 READ mapAxis1 WRITE setMapAxis1 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis2 READ mapAxis2 WRITE setMapAxis2 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis3 READ mapAxis3 WRITE setMapAxis3 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis4 READ mapAxis4 WRITE setMapAxis4 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis5 READ mapAxis5 WRITE setMapAxis5 NOTIFY joyStickChanged)
    Q_PROPERTY(int   mapAxis6 READ mapAxis6 WRITE setMapAxis6 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis1 READ invertAxis1 WRITE setInvertAxis1 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis2 READ invertAxis2 WRITE setInvertAxis2 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis3 READ invertAxis3 WRITE setInvertAxis3 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis4 READ invertAxis4 WRITE setInvertAxis4 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis5 READ invertAxis5 WRITE setInvertAxis5 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  invertAxis6 READ invertAxis6 WRITE setInvertAxis6 NOTIFY joyStickChanged)
    Q_PROPERTY(bool  calibrate READ calibrate  WRITE  setCalibrate)
public:
    explicit JoyStick(QObject *parent = 0);
    ~JoyStick();
    // JoyStick configuration
        QString joyStickName() { return m_joyStickName; };
        bool haveJoyStick()       { return m_haveJoyStick; };
        int rawAxis1() { return m_rawAxis1; };
        int rawAxis2() { return m_rawAxis2; };
        int rawAxis3() { return m_rawAxis3; };
        int rawAxis4() { return m_rawAxis4; };
        int rawAxis5() { return m_rawAxis5; };
        int rawAxis6() { return m_rawAxis6; };
        int maxAxis1() { return m_maxAxis1; };
        int maxAxis2() { return m_maxAxis2; };
        int maxAxis3() { return m_maxAxis3; };
        int maxAxis4() { return m_maxAxis4; };
        int maxAxis5() { return m_maxAxis5; };
        int maxAxis6() { return m_maxAxis6; };
        int minAxis1() { return m_minAxis1; };
        int minAxis2() { return m_minAxis2; };
        int minAxis3() { return m_minAxis3; };
        int minAxis4() { return m_minAxis4; };
        int minAxis5() { return m_minAxis5; };
        int minAxis6() { return m_minAxis6; };
        float axis1()  { return m_axis1; };
        float axis2()  { return m_axis2; };
        float axis3()  { return m_axis3; };
        float axis4()  { return m_axis4; };
        float axis5()  { return m_axis5; };
        float axis6()  { return m_axis6; };
        float calAxis1()  { return m_calAxis1; };
        float calAxis2()  { return m_calAxis2; };
        float calAxis3()  { return m_calAxis3; };
        float calAxis4()  { return m_calAxis4; };
        float calAxis5()  { return m_calAxis5; };
        float calAxis6()  { return m_calAxis6; };
        int mapAxis1() { return m_mapAxis[0]; };
        int mapAxis2() { return m_mapAxis[1]; };
        int mapAxis3() { return m_mapAxis[2]; };
        int mapAxis4() { return m_mapAxis[3]; };
        int mapAxis5() { return m_mapAxis[4]; };
        int mapAxis6() { return m_mapAxis[5]; };
        int invertAxis1() { return m_invertAxis1; };
        int invertAxis2() { return m_invertAxis2; };
        int invertAxis3() { return m_invertAxis3; };
        int invertAxis4() { return m_invertAxis4; };
        int invertAxis5() { return m_invertAxis5; };
        int invertAxis6() { return m_invertAxis6; };
        void setInvertAxis1(bool val) { m_invertAxis1=val; };
        void setInvertAxis2(bool val) { m_invertAxis2=val; };
        void setInvertAxis3(bool val) { m_invertAxis3=val; };
        void setInvertAxis4(bool val) { m_invertAxis4=val; };
        void setInvertAxis5(bool val) { m_invertAxis5=val; };
        void setInvertAxis6(bool val) { m_invertAxis6=val; };
        void setMapAxis1(int val) { m_mapAxis[0]=val; };
        void setMapAxis2(int val) { m_mapAxis[1]=val; };
        void setMapAxis3(int val) { m_mapAxis[2]=val; };
        void setMapAxis4(int val) { m_mapAxis[3]=val; };
        void setMapAxis5(int val) { m_mapAxis[4]=val; };
        void setMapAxis6(int val) { m_mapAxis[5]=val; };
        float getMapped(int axis);
        void setMapped(int axis,float value);
        bool calibrate()  { return m_joyCal; };
        void setCalibrate(bool val);
        void saveCalibration();



signals:
    void joyStickChanged();
public slots:
    void updateJoyStick();
private:
        // Joystick
     QSettings *m_joySettings;
     bool       m_haveJoyStick;
     QString    m_joyStickName;
     bool       m_joyCal;
            int m_rawAxis1;
            int m_rawAxis2;
            int m_rawAxis3;
            int m_rawAxis4;
            int m_rawAxis5;
            int m_rawAxis6;
            float m_axis1;
            float m_axis2;
            float m_axis3;
            float m_axis4;
            float m_axis5;
            float m_axis6;
            float m_calAxis1;
            float m_calAxis2;
            float m_calAxis3;
            float m_calAxis4;
            float m_calAxis5;
            float m_calAxis6;
            int m_minAxis1;
            int m_minAxis2;
            int m_minAxis3;
            int m_minAxis4;
            int m_minAxis5;
            int m_minAxis6;
            int m_maxAxis1;
            int m_maxAxis2;
            int m_maxAxis3;
            int m_maxAxis4;
            int m_maxAxis5;
            int m_maxAxis6;
            bool m_invertAxis1;
            bool m_invertAxis2;
            bool m_invertAxis3;
            bool m_invertAxis4;
            bool m_invertAxis5;
            bool m_invertAxis6;
            int m_mapAxis[6];
            QTimer joyStickTimer;
#ifdef HAVE_SDL

    SDL_Joystick *joyStick;
#endif
};

#endif // JOYSTICK_H
