#-------------------------------------------------
#
# Project created by QtCreator 2010-10-12T20:45:34
#
#-------------------------------------------------

QT       += core gui declarative network

CONFIG += mobility link_pkgconfig
MOBILITY += sensors
TARGET = mardrone
TEMPLATE = app
AR_DRONE_SDK = ARDrone_SDK_Version_1_8_20110726
#LIBS += -Lardrone-lib-x86 -lvlib -lsdk
#LIBS += -L../mardrone/ardrone-lib-arm -lvlib -lsdk

#For Android
macx {
message("Compiling for Mac OSx")
LIBS += -L../mardrone/ardrone-lib-osx -lvlib
LIBS += -framework SDL
DEFINES+=HAVE_SDL
}
android {
 LIBS += -L../mardrone/ardrone-lib-android -lvlib -lsdk  /home/kate/necessitas/android-ndk-r6b/toolchains/arm-linux-androideabi-4.4.3/prebuilt/linux-x86/lib/gcc/arm-linux-androideabi/4.4.3/libgcc.a
}
SUBDIRS += $${AR_DRONE_SDK}

system(pkg-config --exists QtSensors){
    message("I have QtSensors")
    DEFINES+=QT_SENSORS
}

message("QMAKESPEC is:")
message($$QMAKESPEC)

SOURCES += main.cpp\
    dronelib/dronecontrol.cpp \
    dronelib/navdata.cpp \
    dronelib/video.cpp \
    gauges/gauge.cpp \
    gauges/gaugelabel.cpp \
    gauges/gaugetape.cpp \
    gauges/gaugehorizon.cpp \
    dronelib/joystick.cpp \
    qdeclarativetoucharea.cpp

INCLUDEPATH += dronelib \
               gauges \
               $${AR_DRONE_SDK}/ARDroneLib/Soft/Common \
               $${AR_DRONE_SDK}/ARDroneLib/VP_SDK \
               $${AR_DRONE_SDK}/ARDroneLib/VP_SDK/VP_Os/linux \
               $${AR_DRONE_SDK}/ARDroneLib/VP_SDK/VP_Os \
               $${AR_DRONE_SDK}/ARDroneLib/Soft/Lib \
               $${AR_DRONE_SDK}/ARDroneLib/VLIB \
               $${AR_DRONE_SDK}/ARDroneLib

HEADERS  +=  dronelib/dronecontrol.h \
    dronelib/navdata.h \
    dronelib/video.h \
    gauges/gauge.h \
    gauges/gaugelabel.h \
    gauges/gaugetape.h \
    gauges/gaugehorizon.h \
    dronelib/joystick.h \
    qdeclarativetoucharea.h

system(pkg-config --exists sdl){
    message("I have sdl")
    DEFINES+=HAVE_SDL
    SOURCES +=
    HEADERS +=
    LIBS+=-lSDL
}


OTHER_FILES += \
    JoyStick2.qml \
    debian/changelog \
    debian/compat \
    debian/control \
    debian/copyright \
    debian/README \
    debian/rules \
    ardrone1.desktop \
    BarGauge.qml \
    ConfigDialog.qml \
    ardrone_harmattan.qml \
    ardrone_desktop.qml \
    ConfigDialogDesktop.qml \
    gauges/AltGauge.qml \
    gauges/alt2.png \
    gauges/needle1.png \
    gauges/needle2.png \
    gauges/EfisPFD.qml \
    gauges/qmldir.txt \
    dronelib/JoyStickCalibrator.qml \
    dronelib/JoyStickIndicator.qml \
    CalibrateDialog.qml \
    JoyStickCalibrator.qml \
    JoyStickIndicator.qml \
    JoyStickTouch.qml \
    gauges/qmldir \
    qtc_packaging/debian_harmattan/rules \
    qtc_packaging/debian_harmattan/README \
    qtc_packaging/debian_harmattan/manifest.aegis \
    qtc_packaging/debian_harmattan/copyright \
    qtc_packaging/debian_harmattan/control \
    qtc_packaging/debian_harmattan/compat \
    qtc_packaging/debian_harmattan/changelog \
    gauges/AttitudeGauge.qml \
    CalibrateDialogDesktop.qml \
    JoyStickCalibratorDesktop.qml \
    ardrone_symbian.qml \
    ConfigDialogSymbian.qml \
    gauges/GenericGauge.qml \
    gauges/HeadingGauge.qml

unix:!symbian {
    maemo5 {
        target.path = /opt/usr/bin
    } else {
        target.path = /usr/local/bin
    }
    INSTALLS += target
}

unix:!symbian {
    desktopfile.files = $${TARGET}.desktop
    maemo5 {
        desktopfile.path = /usr/share/applications/hildon
        icon64.path = /usr/share/icons/hicolor/64x64/apps
        icon64.files = $${TARGET}.png
        INSTALLS += icon64
    } else {
        desktopfile.path = /usr/share/applications
    }
    INSTALLS += desktopfile
}

RESOURCES += \
    ardrone.qrc
































